﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Common;

namespace HeuristicLab.Algorithms.Bandits.BanditPolicies {
  public class SingleArmPolicy : IBanditPolicy {
    public int Arm { get; private set; }

    public SingleArmPolicy(int arm) {
      this.Arm = arm;
    }

    public override string ToString() {
      return string.Format("SingleArmPolicy({0})", Arm);
    }

    public int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actionInfos) {
      return Arm;
    }

    public IBanditPolicyActionInfo CreateActionInfo() {
      return new DefaultPolicyActionInfo();
    }
  }
}
